/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2008-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2011-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: target_serial.h 1801 2015-03-27 06:34:43Z t_ishikawa $
 */

/*
 *		ꥢI/OǥХSIO˥ɥ饤СNIOS2_DEVѡ
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "nios2_system.h"

/*
 *  SIOγߥϥɥΥ٥ֹ
 */
#ifdef USE_UART

#define INTNO_SIO	(UART_PORT1_INT)        /* ֹ */
#define INTPRI_SIO	2                       /* ͥ */

/*
 *  ץå¸⥸塼UARTѡ
 */
#include "nios2_gcc/uart.h"

#ifndef UART_BAUDRATE
#define UART_BAUDRATE	921600
#endif

/*
 *  DIVISOR쥸ꤹ
 */
#if   UART_BAUDRATE == 115200
#define UART_DIVISOR_VALUE	UINT_C(868)
#elif UART_BAUDRATE == 230400
#define UART_DIVISOR_VALUE	UINT_C(434)
#elif UART_BAUDRATE == 460800
#define UART_DIVISOR_VALUE	UINT_C(217)
#elif UART_BAUDRATE == 921600
#define UART_DIVISOR_VALUE	UINT_C(108) /* 108 or 109 */
#else
#error "UART_BAUDRATE" is invalid.
#endif

LOCAL_INLINE void
uart_set_baudrate(void)
{
	sil_wrw_iop((void *) (UART_PORT1_BASE + UART_DIVISOR_OFFSET), UART_DIVISOR_VALUE);
}


#else /* USE_UART */

#define INTNO_SIO	(JTAG_UART_PORT1_INT)   /* ֹ */
#define INTPRI_SIO	2                       /* ͥ */

/*
 *  ץå¸⥸塼JTAG UARTѡ
 */
#include "nios2_gcc/jtag_uart.h"

#endif /* USE_UART */

#endif /* TOPPERS_TARGET_SERIAL_H */
